# Generated by Django 4.2.1 on 2023-07-29 07:47

from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Banner",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "message",
                    models.TextField(
                        help_text="You can use Markdown", verbose_name="message"
                    ),
                ),
                (
                    "message_html",
                    models.TextField(
                        blank=True,
                        help_text="HTML version of the message, automatically generated on save",
                        null=True,
                        verbose_name="message_html",
                    ),
                ),
                ("title", models.CharField(max_length=255, verbose_name="title")),
                ("priority", models.IntegerField(default=0, verbose_name="priority")),
                (
                    "display_from",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="display from"
                    ),
                ),
                (
                    "display_to",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="display to"
                    ),
                ),
            ],
            options={
                "verbose_name": "banner",
                "verbose_name_plural": "banners",
                "ordering": ("priority",),
            },
        ),
        migrations.CreateModel(
            name="Topic",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("edited", models.BooleanField(default=False, verbose_name="edited")),
                (
                    "edited_on",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="created_on"
                    ),
                ),
                (
                    "message",
                    models.TextField(
                        help_text="You can use Markdown", verbose_name="message"
                    ),
                ),
                (
                    "message_html",
                    models.TextField(
                        blank=True,
                        help_text="HTML version of the message, automatically generated on save",
                        null=True,
                        verbose_name="message_html",
                    ),
                ),
                (
                    "created_on",
                    models.DateTimeField(
                        default=django.utils.timezone.now, verbose_name="created_on"
                    ),
                ),
                ("subject", models.CharField(max_length=255, verbose_name="subject")),
            ],
            options={
                "verbose_name": "topic",
                "verbose_name_plural": "topics",
                "ordering": ("created_on",),
                "permissions": [
                    (
                        "view_topic_edition_infos",
                        "Can view topic infos related to edition",
                    )
                ],
            },
        ),
        migrations.CreateModel(
            name="UserProfile",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("edited", models.BooleanField(default=False, verbose_name="edited")),
                (
                    "edited_on",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="created_on"
                    ),
                ),
                (
                    "nickname",
                    models.CharField(
                        max_length=255, null=True, unique=True, verbose_name="nickname"
                    ),
                ),
                (
                    "abstract",
                    models.TextField(blank=True, null=True, verbose_name="abstract"),
                ),
                (
                    "edited_by",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="edited_by",
                    ),
                ),
                (
                    "user",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="profile",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="user",
                    ),
                ),
            ],
            options={
                "verbose_name": "User profile",
                "verbose_name_plural": "User profiles",
                "ordering": ("nickname",),
                "permissions": [
                    (
                        "view_user_profile_edition_infos",
                        "Can view user profile infos related to edition",
                    )
                ],
            },
        ),
        migrations.CreateModel(
            name="UserProfileExternalLinks",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("priority", models.IntegerField(default=0, verbose_name="priority")),
                ("label", models.CharField(max_length=255, verbose_name="label")),
                (
                    "url",
                    models.URLField(
                        validators=[
                            django.core.validators.URLValidator(
                                schemes=(
                                    "https",
                                    "xmpp",
                                    "matrix",
                                    "ircs",
                                    "irc",
                                    "mailto",
                                )
                            )
                        ],
                        verbose_name="URL",
                    ),
                ),
                (
                    "user_profile",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="external_link_set",
                        to="slow_forum.userprofile",
                        verbose_name="user profile",
                    ),
                ),
            ],
            options={
                "verbose_name": "User profile extrenal link",
                "verbose_name_plural": "User profile extrenal links",
                "ordering": ("label",),
            },
        ),
        migrations.CreateModel(
            name="TopicReply",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("edited", models.BooleanField(default=False, verbose_name="edited")),
                (
                    "edited_on",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="created_on"
                    ),
                ),
                (
                    "message",
                    models.TextField(
                        help_text="You can use Markdown", verbose_name="message"
                    ),
                ),
                (
                    "message_html",
                    models.TextField(
                        blank=True,
                        help_text="HTML version of the message, automatically generated on save",
                        null=True,
                        verbose_name="message_html",
                    ),
                ),
                (
                    "created_on",
                    models.DateTimeField(
                        default=django.utils.timezone.now, verbose_name="created_on"
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="created_by",
                    ),
                ),
                (
                    "edited_by",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="edited_by",
                    ),
                ),
                (
                    "topic",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="replies_set",
                        to="slow_forum.topic",
                        verbose_name="topic",
                    ),
                ),
            ],
            options={
                "verbose_name": "Topic reply",
                "verbose_name_plural": "Topic replies",
                "ordering": ("created_on",),
                "permissions": [
                    (
                        "view_topic_edition_infos",
                        "Can view topic infos related to edition",
                    )
                ],
            },
        ),
        migrations.CreateModel(
            name="TopicCategory",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("edited", models.BooleanField(default=False, verbose_name="edited")),
                (
                    "edited_on",
                    models.DateTimeField(
                        blank=True, null=True, verbose_name="created_on"
                    ),
                ),
                (
                    "created_on",
                    models.DateTimeField(
                        default=django.utils.timezone.now, verbose_name="created_on"
                    ),
                ),
                (
                    "title",
                    models.CharField(max_length=255, unique=True, verbose_name="title"),
                ),
                ("priority", models.IntegerField(default=0, verbose_name="priority")),
                (
                    "description",
                    models.TextField(
                        help_text="You can use Markdown", verbose_name="description"
                    ),
                ),
                (
                    "created_by",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="created_by",
                    ),
                ),
                (
                    "edited_by",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="edited_by",
                    ),
                ),
            ],
            options={
                "verbose_name": "topic category",
                "verbose_name_plural": "topic categories",
                "ordering": ("priority",),
            },
        ),
        migrations.AddField(
            model_name="topic",
            name="category",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to="slow_forum.topiccategory",
                verbose_name="category",
            ),
        ),
        migrations.AddField(
            model_name="topic",
            name="created_by",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to=settings.AUTH_USER_MODEL,
                verbose_name="created_by",
            ),
        ),
        migrations.AddField(
            model_name="topic",
            name="edited_by",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to=settings.AUTH_USER_MODEL,
                verbose_name="edited_by",
            ),
        ),
    ]
